Index: uspace/srv/net/tl/tcp/tcp.c
===================================================================
--- uspace/srv/net/tl/tcp/tcp.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/tl/tcp/tcp.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -127,4 +127,9 @@
 typedef struct tcp_timeout tcp_timeout_t;
 
+/** Type definition of the TCP timeout pointer.
+ *  @see tcp_timeout
+ */
+typedef tcp_timeout_t *tcp_timeout_ref;
+
 /** TCP reply timeout data.
  *  Used as a timeouting fibril argument.
@@ -139,5 +144,5 @@
 
 	/** Local sockets. */
-	socket_cores_t *local_sockets;
+	socket_cores_ref local_sockets;
 
 	/** Socket identifier. */
@@ -160,10 +165,10 @@
 };
 
-static int tcp_release_and_return(packet_t *, int);
-static void tcp_prepare_operation_header(socket_core_t *, tcp_socket_data_t *,
-    tcp_header_t *, int synchronize, int);
-static int tcp_prepare_timeout(int (*)(void *), socket_core_t *,
-    tcp_socket_data_t *, size_t, tcp_socket_state_t, suseconds_t, int);
-static void tcp_free_socket_data(socket_core_t *);
+static int tcp_release_and_return(packet_t, int);
+static void tcp_prepare_operation_header(socket_core_ref, tcp_socket_data_ref,
+    tcp_header_ref, int synchronize, int);
+static int tcp_prepare_timeout(int (*)(void *), socket_core_ref,
+    tcp_socket_data_ref, size_t, tcp_socket_state_t, suseconds_t, int);
+static void tcp_free_socket_data(socket_core_ref);
 
 static int tcp_timeout(void *);
@@ -171,49 +176,49 @@
 static int tcp_release_after_timeout(void *);
 
-static int tcp_process_packet(device_id_t, packet_t *, services_t);
-static int tcp_connect_core(socket_core_t *, socket_cores_t *,
+static int tcp_process_packet(device_id_t, packet_t, services_t);
+static int tcp_connect_core(socket_core_ref, socket_cores_ref,
     struct sockaddr *, socklen_t);
-static int tcp_queue_prepare_packet(socket_core_t *, tcp_socket_data_t *,
-    packet_t *, size_t);
-static int tcp_queue_packet(socket_core_t *, tcp_socket_data_t *, packet_t *,
+static int tcp_queue_prepare_packet(socket_core_ref, tcp_socket_data_ref,
+    packet_t, size_t);
+static int tcp_queue_packet(socket_core_ref, tcp_socket_data_ref, packet_t,
     size_t);
-static packet_t *tcp_get_packets_to_send(socket_core_t *, tcp_socket_data_t *);
-static void tcp_send_packets(device_id_t, packet_t *);
-
-static void tcp_process_acknowledgement(socket_core_t *, tcp_socket_data_t *,
-    tcp_header_t *);
-static packet_t *tcp_send_prepare_packet(socket_core_t *, tcp_socket_data_t *,
-    packet_t *, size_t, size_t);
-static packet_t *tcp_prepare_copy(socket_core_t *, tcp_socket_data_t *,
-    packet_t *, size_t, size_t);
-/* static */ void tcp_retransmit_packet(socket_core_t *, tcp_socket_data_t *,
+static packet_t tcp_get_packets_to_send(socket_core_ref, tcp_socket_data_ref);
+static void tcp_send_packets(device_id_t, packet_t);
+
+static void tcp_process_acknowledgement(socket_core_ref, tcp_socket_data_ref,
+    tcp_header_ref);
+static packet_t tcp_send_prepare_packet(socket_core_ref, tcp_socket_data_ref,
+    packet_t, size_t, size_t);
+static packet_t tcp_prepare_copy(socket_core_ref, tcp_socket_data_ref, packet_t,
+    size_t, size_t);
+/* static */ void tcp_retransmit_packet(socket_core_ref, tcp_socket_data_ref,
     size_t);
-static int tcp_create_notification_packet(packet_t **, socket_core_t *,
-    tcp_socket_data_t *, int, int);
-static void tcp_refresh_socket_data(tcp_socket_data_t *);
-
-static void tcp_initialize_socket_data(tcp_socket_data_t *);
-
-static int tcp_process_listen(socket_core_t *, tcp_socket_data_t *,
-    tcp_header_t *, packet_t *, struct sockaddr *, struct sockaddr *, size_t);
-static int tcp_process_syn_sent(socket_core_t *, tcp_socket_data_t *,
-    tcp_header_t *, packet_t *);
-static int tcp_process_syn_received(socket_core_t *, tcp_socket_data_t *,
-    tcp_header_t *, packet_t *);
-static int tcp_process_established(socket_core_t *, tcp_socket_data_t *,
-    tcp_header_t *, packet_t *, int, size_t);
-static int tcp_queue_received_packet(socket_core_t *, tcp_socket_data_t *,
-    packet_t *, int, size_t);
-
-static int tcp_received_msg(device_id_t, packet_t *, services_t, services_t);
+static int tcp_create_notification_packet(packet_t *, socket_core_ref,
+    tcp_socket_data_ref, int, int);
+static void tcp_refresh_socket_data(tcp_socket_data_ref);
+
+static void tcp_initialize_socket_data(tcp_socket_data_ref);
+
+static int tcp_process_listen(socket_core_ref, tcp_socket_data_ref,
+    tcp_header_ref, packet_t, struct sockaddr *, struct sockaddr *, size_t);
+static int tcp_process_syn_sent(socket_core_ref, tcp_socket_data_ref,
+    tcp_header_ref, packet_t);
+static int tcp_process_syn_received(socket_core_ref, tcp_socket_data_ref,
+    tcp_header_ref, packet_t);
+static int tcp_process_established(socket_core_ref, tcp_socket_data_ref,
+    tcp_header_ref, packet_t, int, size_t);
+static int tcp_queue_received_packet(socket_core_ref, tcp_socket_data_ref,
+    packet_t, int, size_t);
+
+static int tcp_received_msg(device_id_t, packet_t, services_t, services_t);
 static int tcp_process_client_messages(ipc_callid_t, ipc_call_t);
 
-static int tcp_listen_message(socket_cores_t *, int, int);
-static int tcp_connect_message(socket_cores_t *, int, struct sockaddr *,
+static int tcp_listen_message(socket_cores_ref, int, int);
+static int tcp_connect_message(socket_cores_ref, int, struct sockaddr *,
     socklen_t);
-static int tcp_recvfrom_message(socket_cores_t *, int, int, size_t *);
-static int tcp_send_message(socket_cores_t *, int, int, size_t *, int);
-static int tcp_accept_message(socket_cores_t *, int, int, size_t *, size_t *);
-static int tcp_close_message(socket_cores_t *, int);
+static int tcp_recvfrom_message(socket_cores_ref, int, int, size_t *);
+static int tcp_send_message(socket_cores_ref, int, int, size_t *, int);
+static int tcp_accept_message(socket_cores_ref, int, int, size_t *, size_t *);
+static int tcp_close_message(socket_cores_ref, int);
 
 /** TCP global data. */
@@ -224,6 +229,6 @@
  * @param[in] client_connection The client connection processing function. The
  *			module skeleton propagates its own one.
- * @return		EOK on success.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 int tcp_initialize(async_client_conn_t client_connection)
@@ -262,5 +267,5 @@
 }
 
-int tcp_received_msg(device_id_t device_id, packet_t *packet,
+int tcp_received_msg(device_id_t device_id, packet_t packet,
     services_t receiver, services_t error)
 {
@@ -280,13 +285,13 @@
 }
 
-int tcp_process_packet(device_id_t device_id, packet_t *packet, services_t error)
+int tcp_process_packet(device_id_t device_id, packet_t packet, services_t error)
 {
 	size_t length;
 	size_t offset;
 	int result;
-	tcp_header_t *header;
-	socket_core_t *socket;
-	tcp_socket_data_t *socket_data;
-	packet_t *next_packet;
+	tcp_header_ref header;
+	socket_core_ref socket;
+	tcp_socket_data_ref socket_data;
+	packet_t next_packet;
 	size_t total_length;
 	uint32_t checksum;
@@ -338,5 +343,5 @@
 
 	/* Get tcp header */
-	header = (tcp_header_t *) packet_get_data(packet);
+	header = (tcp_header_ref) packet_get_data(packet);
 	if (!header)
 		return tcp_release_and_return(packet, NO_DATA);
@@ -375,5 +380,5 @@
 
 	printf("socket id %d\n", socket->socket_id);
-	socket_data = (tcp_socket_data_t *) socket->specific_data;
+	socket_data = (tcp_socket_data_ref) socket->specific_data;
 	assert(socket_data);
 
@@ -492,10 +497,10 @@
 }
 
-int tcp_process_established(socket_core_t *socket, tcp_socket_data_t *
-    socket_data, tcp_header_t *header, packet_t *packet, int fragments,
+int tcp_process_established(socket_core_ref socket, tcp_socket_data_ref
+    socket_data, tcp_header_ref header, packet_t packet, int fragments,
     size_t total_length)
 {
-	packet_t *next_packet;
-	packet_t *tmp_packet;
+	packet_t next_packet;
+	packet_t tmp_packet;
 	uint32_t old_incoming;
 	size_t order;
@@ -800,9 +805,9 @@
 }
 
-int tcp_queue_received_packet(socket_core_t *socket,
-    tcp_socket_data_t *socket_data, packet_t *packet, int fragments,
+int tcp_queue_received_packet(socket_core_ref socket,
+    tcp_socket_data_ref socket_data, packet_t packet, int fragments,
     size_t total_length)
 {
-	packet_dimension_t *packet_dimension;
+	packet_dimension_ref packet_dimension;
 	int rc;
 
@@ -837,8 +842,8 @@
 }
 
-int tcp_process_syn_sent(socket_core_t *socket, tcp_socket_data_t *
-    socket_data, tcp_header_t *header, packet_t *packet)
-{
-	packet_t *next_packet;
+int tcp_process_syn_sent(socket_core_ref socket, tcp_socket_data_ref
+    socket_data, tcp_header_ref header, packet_t packet)
+{
+	packet_t next_packet;
 	int rc;
 
@@ -895,12 +900,12 @@
 }
 
-int tcp_process_listen(socket_core_t *listening_socket,
-    tcp_socket_data_t *listening_socket_data, tcp_header_t *header,
-    packet_t *packet, struct sockaddr *src, struct sockaddr *dest,
+int tcp_process_listen(socket_core_ref listening_socket,
+    tcp_socket_data_ref listening_socket_data, tcp_header_ref header,
+    packet_t packet, struct sockaddr *src, struct sockaddr *dest,
     size_t addrlen)
 {
-	packet_t *next_packet;
-	socket_core_t *socket;
-	tcp_socket_data_t *socket_data;
+	packet_t next_packet;
+	socket_core_ref socket;
+	tcp_socket_data_ref socket_data;
 	int socket_id;
 	int listening_socket_id = listening_socket->socket_id;
@@ -917,5 +922,5 @@
 		return tcp_release_and_return(packet, EINVAL);
 
-	socket_data = (tcp_socket_data_t *) malloc(sizeof(*socket_data));
+	socket_data = (tcp_socket_data_ref) malloc(sizeof(*socket_data));
 	if (!socket_data)
 		return tcp_release_and_return(packet, ENOMEM);
@@ -974,5 +979,5 @@
 	}
 	listening_socket_data =
-	    (tcp_socket_data_t *) listening_socket->specific_data;
+	    (tcp_socket_data_ref) listening_socket->specific_data;
 	assert(listening_socket_data);
 
@@ -986,5 +991,5 @@
 		return ENOTSOCK;
 	}
-	socket_data = (tcp_socket_data_t *) socket->specific_data;
+	socket_data = (tcp_socket_data_ref) socket->specific_data;
 	assert(socket_data);
 
@@ -1055,9 +1060,9 @@
 }
 
-int tcp_process_syn_received(socket_core_t *socket,
-    tcp_socket_data_t *socket_data, tcp_header_t *header, packet_t *packet)
-{
-	socket_core_t *listening_socket;
-	tcp_socket_data_t *listening_socket_data;
+int tcp_process_syn_received(socket_core_ref socket,
+    tcp_socket_data_ref socket_data, tcp_header_ref header, packet_t packet)
+{
+	socket_core_ref listening_socket;
+	tcp_socket_data_ref listening_socket_data;
 	int rc;
 
@@ -1081,5 +1086,5 @@
 	if (listening_socket) {
 		listening_socket_data =
-		    (tcp_socket_data_t *) listening_socket->specific_data;
+		    (tcp_socket_data_ref) listening_socket->specific_data;
 		assert(listening_socket_data);
 
@@ -1122,12 +1127,12 @@
 }
 
-void tcp_process_acknowledgement(socket_core_t *socket,
-    tcp_socket_data_t *socket_data, tcp_header_t *header)
+void tcp_process_acknowledgement(socket_core_ref socket,
+    tcp_socket_data_ref socket_data, tcp_header_ref header)
 {
 	size_t number;
 	size_t length;
-	packet_t *packet;
-	packet_t *next;
-	packet_t *acknowledged = NULL;
+	packet_t packet;
+	packet_t next;
+	packet_t acknowledged = NULL;
 	uint32_t old;
 
@@ -1222,6 +1227,6 @@
  * @param[out] answer_count The last parameter for the actual answer in the
  *			answer parameter.
- * @return		EOK on success.
- * @return		ENOTSUP if the message is not known.
+ * @returns		EOK on success.
+ * @returns		ENOTSUP if the message is not known.
  *
  * @see tcp_interface.h
@@ -1232,5 +1237,5 @@
     ipc_call_t *answer, int *answer_count)
 {
-	packet_t *packet;
+	packet_t packet;
 	int rc;
 
@@ -1260,5 +1265,5 @@
 }
 
-void tcp_refresh_socket_data(tcp_socket_data_t *socket_data)
+void tcp_refresh_socket_data(tcp_socket_data_ref socket_data)
 {
 	assert(socket_data);
@@ -1276,5 +1281,5 @@
 }
 
-void tcp_initialize_socket_data(tcp_socket_data_t *socket_data)
+void tcp_initialize_socket_data(tcp_socket_data_ref socket_data)
 {
 	assert(socket_data);
@@ -1299,7 +1304,7 @@
 	ipc_call_t answer;
 	int answer_count;
-	tcp_socket_data_t *socket_data;
-	socket_core_t *socket;
-	packet_dimension_t *packet_dimension;
+	tcp_socket_data_ref socket_data;
+	socket_core_ref socket;
+	packet_dimension_ref packet_dimension;
 
 	/*
@@ -1331,5 +1336,5 @@
 		case NET_SOCKET:
 			socket_data =
-			    (tcp_socket_data_t *) malloc(sizeof(*socket_data));
+			    (tcp_socket_data_ref) malloc(sizeof(*socket_data));
 			if (!socket_data) {
 				res = ENOMEM;
@@ -1378,5 +1383,5 @@
 				    SOCKET_GET_SOCKET_ID(call));
 				if (socket) {
-					socket_data = (tcp_socket_data_t *)
+					socket_data = (tcp_socket_data_ref)
 					    socket->specific_data;
 					assert(socket_data);
@@ -1535,8 +1540,8 @@
 int tcp_timeout(void *data)
 {
-	tcp_timeout_t *timeout = data;
+	tcp_timeout_ref timeout = data;
 	int keep_write_lock = false;
-	socket_core_t *socket;
-	tcp_socket_data_t *socket_data;
+	socket_core_ref socket;
+	tcp_socket_data_ref socket_data;
 
 	assert(timeout);
@@ -1556,5 +1561,5 @@
 		goto out;
 	
-	socket_data = (tcp_socket_data_t *) socket->specific_data;
+	socket_data = (tcp_socket_data_ref) socket->specific_data;
 	assert(socket_data);
 	if (socket_data->local_sockets != timeout->local_sockets)
@@ -1612,7 +1617,7 @@
 int tcp_release_after_timeout(void *data)
 {
-	tcp_timeout_t *timeout = data;
-	socket_core_t *socket;
-	tcp_socket_data_t *socket_data;
+	tcp_timeout_ref timeout = data;
+	socket_core_ref socket;
+	tcp_socket_data_ref socket_data;
 	fibril_rwlock_t *local_lock;
 
@@ -1630,5 +1635,5 @@
 
 	if (socket && (socket->socket_id == timeout->socket_id)) {
-		socket_data = (tcp_socket_data_t *) socket->specific_data;
+		socket_data = (tcp_socket_data_ref) socket->specific_data;
 		assert(socket_data);
 		if (socket_data->local_sockets == timeout->local_sockets) {
@@ -1651,9 +1656,9 @@
 }
 
-void tcp_retransmit_packet(socket_core_t *socket, tcp_socket_data_t *
+void tcp_retransmit_packet(socket_core_ref socket, tcp_socket_data_ref
     socket_data, size_t sequence_number)
 {
-	packet_t *packet;
-	packet_t *copy;
+	packet_t packet;
+	packet_t copy;
 	size_t data_length;
 
@@ -1678,9 +1683,9 @@
 }
 
-int tcp_listen_message(socket_cores_t *local_sockets, int socket_id,
+int tcp_listen_message(socket_cores_ref local_sockets, int socket_id,
     int backlog)
 {
-	socket_core_t *socket;
-	tcp_socket_data_t *socket_data;
+	socket_core_ref socket;
+	tcp_socket_data_ref socket_data;
 
 	assert(local_sockets);
@@ -1695,5 +1700,5 @@
 	
 	/* Get the socket specific data */
-	socket_data = (tcp_socket_data_t *) socket->specific_data;
+	socket_data = (tcp_socket_data_ref) socket->specific_data;
 	assert(socket_data);
 
@@ -1704,8 +1709,8 @@
 }
 
-int tcp_connect_message(socket_cores_t *local_sockets, int socket_id,
+int tcp_connect_message(socket_cores_ref local_sockets, int socket_id,
     struct sockaddr *addr, socklen_t addrlen)
 {
-	socket_core_t *socket;
+	socket_core_ref socket;
 	int rc;
 
@@ -1732,9 +1737,9 @@
 }
 
-int tcp_connect_core(socket_core_t *socket, socket_cores_t *local_sockets,
+int tcp_connect_core(socket_core_ref socket, socket_cores_ref local_sockets,
     struct sockaddr *addr, socklen_t addrlen)
 {
-	tcp_socket_data_t *socket_data;
-	packet_t *packet;
+	tcp_socket_data_ref socket_data;
+	packet_t packet;
 	int rc;
 
@@ -1744,5 +1749,5 @@
 
 	/* Get the socket specific data */
-	socket_data = (tcp_socket_data_t *) socket->specific_data;
+	socket_data = (tcp_socket_data_ref) socket->specific_data;
 	assert(socket_data);
 	assert(socket->specific_data == socket_data);
@@ -1823,8 +1828,8 @@
 }
 
-int tcp_queue_prepare_packet(socket_core_t *socket,
-    tcp_socket_data_t *socket_data, packet_t *packet, size_t data_length)
-{
-	tcp_header_t *header;
+int tcp_queue_prepare_packet(socket_core_ref socket,
+    tcp_socket_data_ref socket_data, packet_t packet, size_t data_length)
+{
+	tcp_header_ref header;
 	int rc;
 
@@ -1834,5 +1839,5 @@
 
 	/* Get TCP header */
-	header = (tcp_header_t *) packet_get_data(packet);
+	header = (tcp_header_ref) packet_get_data(packet);
 	if (!header)
 		return NO_DATA;
@@ -1854,6 +1859,6 @@
 }
 
-int tcp_queue_packet(socket_core_t *socket, tcp_socket_data_t *socket_data,
-    packet_t *packet, size_t data_length)
+int tcp_queue_packet(socket_core_ref socket, tcp_socket_data_ref socket_data,
+    packet_t packet, size_t data_length)
 {
 	int rc;
@@ -1876,11 +1881,11 @@
 }
 
-packet_t *tcp_get_packets_to_send(socket_core_t *socket, tcp_socket_data_t *
+packet_t tcp_get_packets_to_send(socket_core_ref socket, tcp_socket_data_ref
     socket_data)
 {
-	packet_t *packet;
-	packet_t *copy;
-	packet_t *sending = NULL;
-	packet_t *previous = NULL;
+	packet_t packet;
+	packet_t copy;
+	packet_t sending = NULL;
+	packet_t previous = NULL;
 	size_t data_length;
 	int rc;
@@ -1936,8 +1941,8 @@
 }
 
-packet_t *tcp_send_prepare_packet(socket_core_t *socket, tcp_socket_data_t *
-    socket_data, packet_t *packet, size_t data_length, size_t sequence_number)
-{
-	tcp_header_t *header;
+packet_t tcp_send_prepare_packet(socket_core_ref socket, tcp_socket_data_ref
+    socket_data, packet_t packet, size_t data_length, size_t sequence_number)
+{
+	tcp_header_ref header;
 	uint32_t checksum;
 	int rc;
@@ -1956,5 +1961,5 @@
 
 	/* Get the header */
-	header = (tcp_header_t *) packet_get_data(packet);
+	header = (tcp_header_ref) packet_get_data(packet);
 	if (!header) {
 		pq_release_remote(tcp_globals.net_phone, packet_get_id(packet));
@@ -1997,8 +2002,8 @@
 }
 
-packet_t *tcp_prepare_copy(socket_core_t *socket, tcp_socket_data_t *
-    socket_data, packet_t *packet, size_t data_length, size_t sequence_number)
-{
-	packet_t *copy;
+packet_t tcp_prepare_copy(socket_core_ref socket, tcp_socket_data_ref
+    socket_data, packet_t packet, size_t data_length, size_t sequence_number)
+{
+	packet_t copy;
 
 	assert(socket);
@@ -2015,7 +2020,7 @@
 }
 
-void tcp_send_packets(device_id_t device_id, packet_t *packet)
-{
-	packet_t *next;
+void tcp_send_packets(device_id_t device_id, packet_t packet)
+{
+	packet_t next;
 
 	while (packet) {
@@ -2027,6 +2032,6 @@
 }
 
-void tcp_prepare_operation_header(socket_core_t *socket,
-    tcp_socket_data_t *socket_data, tcp_header_t *header, int synchronize,
+void tcp_prepare_operation_header(socket_core_ref socket,
+    tcp_socket_data_ref socket_data, tcp_header_ref header, int synchronize,
     int finalize)
 {
@@ -2045,9 +2050,9 @@
 
 int tcp_prepare_timeout(int (*timeout_function)(void *tcp_timeout_t),
-    socket_core_t *socket, tcp_socket_data_t *socket_data,
+    socket_core_ref socket, tcp_socket_data_ref socket_data,
     size_t sequence_number, tcp_socket_state_t state, suseconds_t timeout,
     int globals_read_only)
 {
-	tcp_timeout_t *operation_timeout;
+	tcp_timeout_ref operation_timeout;
 	fid_t fibril;
 
@@ -2091,11 +2096,11 @@
 }
 
-int tcp_recvfrom_message(socket_cores_t *local_sockets, int socket_id,
+int tcp_recvfrom_message(socket_cores_ref local_sockets, int socket_id,
     int flags, size_t *addrlen)
 {
-	socket_core_t *socket;
-	tcp_socket_data_t *socket_data;
+	socket_core_ref socket;
+	tcp_socket_data_ref socket_data;
 	int packet_id;
-	packet_t *packet;
+	packet_t packet;
 	size_t length;
 	int rc;
@@ -2112,5 +2117,5 @@
 		return NO_DATA;
 
-	socket_data = (tcp_socket_data_t *) socket->specific_data;
+	socket_data = (tcp_socket_data_ref) socket->specific_data;
 
 	/* Check state */
@@ -2149,13 +2154,13 @@
 }
 
-int tcp_send_message(socket_cores_t *local_sockets, int socket_id,
+int tcp_send_message(socket_cores_ref local_sockets, int socket_id,
     int fragments, size_t *data_fragment_size, int flags)
 {
-	socket_core_t *socket;
-	tcp_socket_data_t *socket_data;
-	packet_dimension_t *packet_dimension;
-	packet_t *packet;
+	socket_core_ref socket;
+	tcp_socket_data_ref socket_data;
+	packet_dimension_ref packet_dimension;
+	packet_t packet;
 	size_t total_length;
-	tcp_header_t *header;
+	tcp_header_ref header;
 	int index;
 	int result;
@@ -2174,5 +2179,5 @@
 		return NO_DATA;
 
-	socket_data = (tcp_socket_data_t *) socket->specific_data;
+	socket_data = (tcp_socket_data_ref) socket->specific_data;
 
 	/* Check state */
@@ -2225,9 +2230,9 @@
 
 int
-tcp_close_message(socket_cores_t *local_sockets, int socket_id)
-{
-	socket_core_t *socket;
-	tcp_socket_data_t *socket_data;
-	packet_t *packet;
+tcp_close_message(socket_cores_ref local_sockets, int socket_id)
+{
+	socket_core_ref socket;
+	tcp_socket_data_ref socket_data;
+	packet_t packet;
 	int rc;
 
@@ -2238,5 +2243,5 @@
 
 	/* Get the socket specific data */
-	socket_data = (tcp_socket_data_t *) socket->specific_data;
+	socket_data = (tcp_socket_data_ref) socket->specific_data;
 	assert(socket_data);
 
@@ -2293,9 +2298,9 @@
 }
 
-int tcp_create_notification_packet(packet_t **packet, socket_core_t *socket,
-    tcp_socket_data_t *socket_data, int synchronize, int finalize)
-{
-	packet_dimension_t *packet_dimension;
-	tcp_header_t *header;
+int tcp_create_notification_packet(packet_t *packet, socket_core_ref socket,
+    tcp_socket_data_ref socket_data, int synchronize, int finalize)
+{
+	packet_dimension_ref packet_dimension;
+	tcp_header_ref header;
 	int rc;
 
@@ -2327,11 +2332,11 @@
 }
 
-int tcp_accept_message(socket_cores_t *local_sockets, int socket_id,
+int tcp_accept_message(socket_cores_ref local_sockets, int socket_id,
     int new_socket_id, size_t *data_fragment_size, size_t *addrlen)
 {
-	socket_core_t *accepted;
-	socket_core_t *socket;
-	tcp_socket_data_t *socket_data;
-	packet_dimension_t *packet_dimension;
+	socket_core_ref accepted;
+	socket_core_ref socket;
+	tcp_socket_data_ref socket_data;
+	packet_dimension_ref packet_dimension;
 	int rc;
 
@@ -2346,5 +2351,5 @@
 
 	/* Get the socket specific data */
-	socket_data = (tcp_socket_data_t *) socket->specific_data;
+	socket_data = (tcp_socket_data_ref) socket->specific_data;
 	assert(socket_data);
 
@@ -2364,5 +2369,5 @@
 
 		/* Get the socket specific data */
-		socket_data = (tcp_socket_data_t *) accepted->specific_data;
+		socket_data = (tcp_socket_data_ref) accepted->specific_data;
 		assert(socket_data);
 		/* TODO can it be in another state? */
@@ -2400,7 +2405,7 @@
 }
 
-void tcp_free_socket_data(socket_core_t *socket)
-{
-	tcp_socket_data_t *socket_data;
+void tcp_free_socket_data(socket_core_ref socket)
+{
+	tcp_socket_data_ref socket_data;
 
 	assert(socket);
@@ -2409,5 +2414,5 @@
 
 	/* Get the socket specific data */
-	socket_data = (tcp_socket_data_t *) socket->specific_data;
+	socket_data = (tcp_socket_data_ref) socket->specific_data;
 	assert(socket_data);
 
@@ -2442,5 +2447,5 @@
  * @return		The result parameter.
  */
-int tcp_release_and_return(packet_t *packet, int result)
+int tcp_release_and_return(packet_t packet, int result)
 {
 	pq_release_remote(tcp_globals.net_phone, packet_get_id(packet));
@@ -2494,6 +2499,6 @@
 /** Starts the module.
  *
- * @return		EOK on success.
- * @return		Other error codes as defined for each specific module
+ * @returns		EOK on success.
+ * @returns		Other error codes as defined for each specific module
  *			start function.
  */
Index: uspace/srv/net/tl/tcp/tcp.h
===================================================================
--- uspace/srv/net/tl/tcp/tcp.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/tl/tcp/tcp.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -55,8 +55,18 @@
 typedef struct tcp_socket_data tcp_socket_data_t;
 
+/** Type definition of the TCP socket specific data pointer.
+ * @see tcp_socket_data
+ */
+typedef tcp_socket_data_t *tcp_socket_data_ref;
+
 /** Type definition of the TCP operation data.
  * @see tcp_operation
  */
 typedef struct tcp_operation tcp_operation_t;
+
+/** Type definition of the TCP operation data pointer.
+ * @see tcp_operation
+ */
+typedef tcp_operation_t *tcp_operation_ref;
 
 /** TCP socket state type definition.
@@ -239,5 +249,5 @@
 	 * Packets metric is set as their data length.
 	 */
-	packet_t *incoming;
+	packet_t incoming;
 	
 	/** Outgoing packet queue.
@@ -249,5 +259,5 @@
 	 * Packets metric is set as their data length.
 	 */
-	packet_t *outgoing;
+	packet_t outgoing;
 	
 	/** IP pseudo header. */
@@ -262,5 +272,5 @@
 	uint16_t dest_port;
 	/** Parent local sockets. */
-	socket_cores_t *local_sockets;
+	socket_cores_ref local_sockets;
 	
 	/** Local sockets safety lock.
Index: uspace/srv/net/tl/tcp/tcp_header.h
===================================================================
--- uspace/srv/net/tl/tcp/tcp_header.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/net/tl/tcp/tcp_header.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -59,4 +59,9 @@
 typedef struct tcp_header tcp_header_t;
 
+/** Type definition of the transmission datagram header pointer.
+ * @see tcp_header
+ */
+typedef tcp_header_t *tcp_header_ref;
+
 /** Type definition of the transmission datagram header option.
  * @see tcp_option
@@ -64,6 +69,16 @@
 typedef struct tcp_option tcp_option_t;
 
+/** Type definition of the transmission datagram header option pointer.
+ * @see tcp_option
+ */
+typedef tcp_option_t *tcp_option_ref;
+
 /** Type definition of the Maximum segment size TCP option. */
 typedef struct tcp_max_segment_size_option tcp_max_segment_size_option_t;
+
+/** Type definition of the Maximum segment size TCP option pointer.
+ * @see tcp_max_segment_size_option
+ */
+typedef tcp_max_segment_size_option_t *tcp_max_segment_size_option_ref;
 
 /** Transmission datagram header. */
